s_tan.c File Reference
`#include "math_libm.h"`
`#include "math_private.h"`
Include dependency graph for s_tan.c:

Go to the source code of this file.

## Functions

double | tan (double x)

## Function Documentation

double tan | ( | double | x | ) |

Definition at line 45 of file s_tan.c.

References __ieee754_rem_pio2(), __kernel_tan(), GET_HIGH_WORD, and libm_hidden_def.

Referenced by SDL_tan().

{
double y[2],z=0.0;
int32_t n, ix;
/* High word of x. */
GET_HIGH_WORD(ix,x);
/* |x| ~< pi/4 */
ix &= 0x7fffffff;
if(ix <= 0x3fe921fb) return __kernel_tan(x,z,1);
/* tan(Inf or NaN) is NaN */
else if (ix>=0x7ff00000) return x-x; /* NaN */
/* argument reduction needed */
else {
n = __ieee754_rem_pio2(x,y);
return __kernel_tan(y[0],y[1],1-((n&1)<<1)); /* 1 -- n even
-1 -- n odd */
}
}
__ieee754_rem_pio2
int32_t attribute_hidden __ieee754_rem_pio2(double x, y)
Definition: e_rem_pio2.c:94
GET_HIGH_WORD
#define GET_HIGH_WORD(i, d)
Definition: math_private.h:103
n
GLdouble n
Definition: SDL_opengl_glext.h:1952
int32_t
signed int int32_t
Definition: SDL_config_windows.h:61
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
__kernel_tan
double __kernel_tan(double x, double y, int iy)
Definition: k_tan.c:69
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
z
GLdouble GLdouble z
Definition: SDL_opengl_glext.h:404